ci: Allow namespacing of dEQP run results files.
[mesa.git] / .gitlab-ci / deqp-runner.sh
1 #!/bin/sh
2
3 set -ex
4
5 DEQP_OPTIONS="$DEQP_OPTIONS --deqp-surface-width=256 --deqp-surface-height=256"
6 DEQP_OPTIONS="$DEQP_OPTIONS --deqp-surface-type=pbuffer"
7 DEQP_OPTIONS="$DEQP_OPTIONS --deqp-gl-config-name=rgba8888d24s8ms0"
8 DEQP_OPTIONS="$DEQP_OPTIONS --deqp-visibility=hidden"
9
10 # It would be nice to be able to enable the watchdog, so that hangs in a test
11 # don't need to wait the full hour for the run to time out. However, some
12 # shaders end up taking long enough to compile
13 # (dEQP-GLES31.functional.ubo.random.all_per_block_buffers.20 for example)
14 # that they'll sporadically trigger the watchdog.
15 #DEQP_OPTIONS="$DEQP_OPTIONS --deqp-watchdog=enable"
16
17 if [ -z "$DEQP_VER" ]; then
18 echo 'DEQP_VER must be set to something like "gles2", "gles31" or "vk" for the test run'
19 exit 1
20 fi
21
22 if [ "$DEQP_VER" = "vk" ]; then
23 if [ -z "$VK_DRIVER" ]; then
24 echo 'VK_DRIVER must be to something like "radeon" or "intel" for the test run'
25 exit 1
26 fi
27 fi
28
29 if [ -z "$DEQP_SKIPS" ]; then
30 echo 'DEQP_SKIPS must be set to something like "deqp-default-skips.txt"'
31 exit 1
32 fi
33
34 INSTALL=`pwd`/install
35
36 # Set up the driver environment.
37 export LD_LIBRARY_PATH=`pwd`/install/lib/
38 export EGL_PLATFORM=surfaceless
39 export VK_ICD_FILENAMES=`pwd`/install/share/vulkan/icd.d/"$VK_DRIVER"_icd.x86_64.json
40
41 # the runner was failing to look for libkms in /usr/local/lib for some reason
42 # I never figured out.
43 export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/local/lib
44
45 RESULTS=`pwd`/results
46 mkdir -p $RESULTS
47
48 # Generate test case list file.
49 if [ "$DEQP_VER" = "vk" ]; then
50 cp /deqp/mustpass/vk-master.txt /tmp/case-list.txt
51 DEQP=/deqp/external/vulkancts/modules/vulkan/deqp-vk
52 else
53 cp /deqp/mustpass/$DEQP_VER-master.txt /tmp/case-list.txt
54 DEQP=/deqp/modules/$DEQP_VER/deqp-$DEQP_VER
55 fi
56
57 # If the job is parallel, take the corresponding fraction of the caselist.
58 # Note: N~M is a gnu sed extension to match every nth line (first line is #1).
59 if [ -n "$CI_NODE_INDEX" ]; then
60 sed -ni $CI_NODE_INDEX~$CI_NODE_TOTAL"p" /tmp/case-list.txt
61 fi
62
63 if [ ! -s /tmp/case-list.txt ]; then
64 echo "Caselist generation failed"
65 exit 1
66 fi
67
68 if [ -n "$DEQP_EXPECTED_FAILS" ]; then
69 XFAIL="--xfail-list $INSTALL/$DEQP_EXPECTED_FAILS"
70 fi
71
72 set +e
73
74 if [ -n "$DEQP_PARALLEL" ]; then
75 JOB="--job $DEQP_PARALLEL"
76 fi
77
78 run_cts() {
79 deqp=$1
80 caselist=$2
81 output=$3
82 deqp-runner \
83 --deqp $deqp \
84 --output $output \
85 --caselist $caselist \
86 --exclude-list $INSTALL/$DEQP_SKIPS \
87 --compact-display false \
88 $XFAIL \
89 $JOB \
90 --allow-flakes true \
91 $DEQP_RUNNER_OPTIONS \
92 -- \
93 $DEQP_OPTIONS
94 }
95
96 report_flakes() {
97 if [ -z "$FLAKES_CHANNEL" ]; then
98 return 0
99 fi
100 flakes=$1
101 bot="$CI_RUNNER_DESCRIPTION-$CI_PIPELINE_ID"
102 channel="$FLAKES_CHANNEL"
103 (
104 echo NICK $bot
105 echo USER $bot unused unused :Gitlab CI Notifier
106 sleep 10
107 echo "JOIN $channel"
108 sleep 1
109 desc="Flakes detected in job: $CI_JOB_URL on $CI_RUNNER_DESCRIPTION"
110 if [ -n "CI_MERGE_REQUEST_SOURCE_BRANCH_NAME" ]; then
111 desc="$desc on branch $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME ($CI_MERGE_REQUEST_TITLE)"
112 fi
113 echo "PRIVMSG $channel :$desc"
114 for flake in `cat $flakes`; do
115 echo "PRIVMSG $channel :$flake"
116 done
117 echo "PRIVMSG $channel :See $CI_JOB_URL/artifacts/browse/results/"
118 echo "QUIT"
119 ) | nc irc.freenode.net 6667 > /dev/null
120
121 }
122
123 extract_xml_result() {
124 testcase=$1
125 shift 1
126 qpas=$*
127 start="#beginTestCaseResult $testcase"
128 for qpa in $qpas; do
129 while IFS= read -r line; do
130 if [ "$line" = "$start" ]; then
131 dst="$testcase.qpa"
132 echo "#beginSession" > $dst
133 echo $line >> $dst
134 while IFS= read -r line; do
135 if [ "$line" = "#endTestCaseResult" ]; then
136 echo $line >> $dst
137 echo "#endSession" >> $dst
138 /deqp/executor/testlog-to-xml $dst "$RESULTS/$testcase$DEQP_RUN_SUFFIX.xml"
139 # copy the stylesheets here so they only end up in artifacts
140 # if we have one or more result xml in artifacts
141 cp /deqp/testlog.css "$RESULTS/"
142 cp /deqp/testlog.xsl "$RESULTS/"
143 return 0
144 fi
145 echo $line >> $dst
146 done
147 return 1
148 fi
149 done < $qpa
150 done
151 }
152
153 extract_xml_results() {
154 qpas=$*
155 while IFS= read -r testcase; do
156 testcase=${testcase%,*}
157 extract_xml_result $testcase $qpas
158 done
159 }
160
161 # Generate junit results
162 generate_junit() {
163 results=$1
164 echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>"
165 echo "<testsuites>"
166 echo "<testsuite name=\"$DEQP_VER-$CI_NODE_INDEX\">"
167 while read line; do
168 testcase=${line%,*}
169 result=${line#*,}
170 # avoid counting Skip's in the # of tests:
171 if [ "$result" = "Skip" ]; then
172 continue;
173 fi
174 echo "<testcase name=\"$testcase\">"
175 if [ "$result" != "Pass" ]; then
176 echo "<failure type=\"$result\">"
177 echo "$result: See $CI_JOB_URL/artifacts/results/$testcase.xml"
178 echo "</failure>"
179 fi
180 echo "</testcase>"
181 done < $results
182 echo "</testsuite>"
183 echo "</testsuites>"
184 }
185
186 parse_renderer() {
187 RENDERER=`grep -A1 TestCaseResult.\*info.renderer $RESULTS/deqp-info.qpa | grep '<Text' | sed 's|.*<Text>||g' | sed 's|</Text>||g'`
188 VERSION=`grep -A1 TestCaseResult.\*info.version $RESULTS/deqp-info.qpa | grep '<Text' | sed 's|.*<Text>||g' | sed 's|</Text>||g'`
189 echo "Renderer: $RENDERER"
190 echo "Version: $VERSION "
191
192 if ! echo $RENDERER | grep -q $DEQP_EXPECTED_RENDERER; then
193 echo "Expected GL_RENDERER $DEQP_EXPECTED_RENDERER"
194 exit 1
195 fi
196 }
197
198 check_renderer() {
199 echo "Capturing renderer info for driver sanity checks"
200 # If you're having trouble loading your driver, uncommenting this may help
201 # debug.
202 # export EGL_LOG_LEVEL=debug
203 VERSION=`echo $DEQP_VER | tr '[a-z]' '[A-Z]'`
204 $DEQP $DEQP_OPTIONS --deqp-case=dEQP-$VERSION.info.\* --deqp-log-filename=$RESULTS/deqp-info.qpa
205 parse_renderer
206 }
207
208 # wrapper to supress +x to avoid spamming the log
209 quiet() {
210 set +x
211 "$@"
212 set -x
213 }
214
215 if [ "$GALLIUM_DRIVER" = "virpipe" ]; then
216 # deqp is to use virpipe, and virgl_test_server llvmpipe
217 export GALLIUM_DRIVER="$GALLIUM_DRIVER"
218
219 GALLIUM_DRIVER=llvmpipe \
220 GALLIVM_PERF="nopt,no_filter_hacks" \
221 VTEST_USE_EGL_SURFACELESS=1 \
222 VTEST_USE_GLES=1 \
223 virgl_test_server >$RESULTS/vtest-log.txt 2>&1 &
224
225 sleep 1
226 fi
227
228 if [ $DEQP_VER != vk ]; then
229 quiet check_renderer
230 fi
231
232 RESULTSFILE=$RESULTS/cts-runner-results$DEQP_RUN_SUFFIX.txt
233 UNEXPECTED_RESULTSFILE=$RESULTS/cts-runner-unexpected-results$DEQP_RUN_SUFFIX.txt
234 FLAKESFILE=$RESULTS/cts-runner-flakes$DEQP_RUN_SUFFIX.txt
235
236 run_cts $DEQP /tmp/case-list.txt $RESULTSFILE
237 DEQP_EXITCODE=$?
238
239 # junit is disabled, because it overloads gitlab.freedesktop.org to parse it.
240 #quiet generate_junit $RESULTSFILE > $RESULTS/results.xml
241
242 if [ $DEQP_EXITCODE -ne 0 ]; then
243 # preserve caselist files in case of failures:
244 cp /tmp/deqp_runner.*.txt $RESULTS/
245 cat $RESULTSFILE | \
246 grep -v ",Pass" | \
247 grep -v ",Skip" | \
248 grep -v ",ExpectedFail" > \
249 $UNEXPECTED_RESULTSFILE.txt
250
251 if [ -z "$DEQP_NO_SAVE_RESULTS" ]; then
252 echo "Some unexpected results found (see cts-runner-results.txt in artifacts for full results):"
253 head -n 50 $UNEXPECTED_RESULTSFILE.txt
254
255 # Save the logs for up to the first 50 unexpected results:
256 head -n 50 $UNEXPECTED_RESULTSFILE.txt | quiet extract_xml_results /tmp/*.qpa
257 else
258 echo "Unexpected results found:"
259 cat $UNEXPECTED_RESULTSFILE.txt
260 fi
261
262 count=`cat $UNEXPECTED_RESULTSFILE.txt | wc -l`
263
264 # Re-run fails to detect flakes. But use a small threshold, if
265 # something was fundamentally broken, we don't want to re-run
266 # the entire caselist
267 else
268 cat $RESULTSFILE | \
269 grep ",Flake" > \
270 $FLAKESFILE
271
272 count=`cat $FLAKESFILE | wc -l`
273 if [ $count -gt 0 ]; then
274 echo "Some flakes found (see cts-runner-flakes.txt in artifacts for full results):"
275 head -n 50 $FLAKESFILE
276
277 if [ -z "$DEQP_NO_SAVE_RESULTS" ]; then
278 # Save the logs for up to the first 50 flakes:
279 head -n 50 $FLAKESFILE | quiet extract_xml_results /tmp/*.qpa
280 fi
281
282 # Report the flakes to IRC channel for monitoring (if configured):
283 quiet report_flakes $FLAKESFILE
284 else
285 # no flakes, so clean-up:
286 rm $FLAKESFILE
287 fi
288 fi
289
290 exit $DEQP_EXITCODE